require_relative '../ezproxy_providers'

class EzproxyProviders::EBookCentral
  def self.parse (path, params)
    data = {
      "provider" => "proquest"
    }

    if (/\/lib\/lancaster\/remoteDocServer\.api/i.match(path))
      data['rtype'] = 'BOOK_PAGE'
      data['mime'] = 'MISC'
      data['page'] = params['pageNum'][0]
      data['remote_id'] = params['remote_id'][0]

    elsif (/\/lib\/lancaster\/detail\.action/i.match(path))
      data['rtype'] = 'TOC'
      data['mime'] = 'HTML'
      data['title_id'] = params['docID'][0]
      data['unit_id'] = params['docID'][0]

    elsif (/\/lib\/lancaster\/reader\.action/i.match(path))
      data['rtype'] = 'BOOK'
      data['mime'] = 'MISC'
      data['title_id'] = params['docID'][0]
      data['unit_id'] = params['docID'][0]

    elsif (/\/lib\/lancaster\/docAccess\.api/i.match(path))
      data['rtype'] = 'TOC'
      data['mime'] = 'JSON'
      data['title_id'] = params['docid'][0]
      data['unit_id'] = params['docid'][0]
      data['remote_id'] = params['remote_id'][0]

    elsif (/\/lib\/lancaster\/docSearch\.api/i.match(path))
      data['rtype'] = 'TOC'
      data['mime'] = 'JSON'
      data['title_id'] = params['docid'][0]
      data['unit_id'] = params['docid'][0]
      data['remote_id'] = params['remote_id'][0]
    end

    return data
  end
end